std::ratio_less_equal(3)

NAME
std::ratio_less_equal - std::ratio_less_equal

Synopsis
   Defined in header <ratio>
   template< class R1, class R2 >
   struct ratio_less_equal : std::integral_constant<bool, /* see below (since C++11)
   */> { };
   If the ratio R1 is less than or equal to the ratio R2, provides the member constant
   value equal true. Otherwise, value is false.
  Helper variable template
   template< class R1, class R2 >
   inline constexpr bool ratio_less_equal_v = ratio_less_equal<R1, (since C++17)
   R2>::value; Inherited from std::integral_constant

Member constants
   value true if R1::num * R2::den <= R2::num * R1::den, or equivalent expression
   [static] that avoids overflow , false otherwise
            (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Example
// Run this code
 #include <ratio>
 #include <iostream>
 auto main() -> int
 {
     static_assert(std::ratio_less_equal<std::ratio<1, 2>, std::ratio<3, 4>>::value,
                   "1/2 <= 3/4");
     if (std::ratio_less_equal<std::ratio<10,11>, std::ratio<11,12>>::value) {
         std::cout << "10/11 <= 11/12" "\n";
     }
     // Since C++17
     static_assert(std::ratio_less_equal_v<std::ratio<10, 11>, std::ratio<11, 12>> );
     if constexpr (std::ratio_less_equal_v<std::ratio<10, 11>, std::ratio<11, 12>>) {
         std::cout << "11/12 <= 12/13" "\n";
     }
 }

Output:
 10/11 <= 11/12
 11/12 <= 12/13

See also